(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-dragdrop', ['exports', '@angular/core'], factory) :
    (factory((global['ngx-dragdrop'] = {}),global.ng.core));
}(this, (function (exports,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var NgxDragDropService = /** @class */ (function () {
        function NgxDragDropService() {
            this.defaultInstanceName = 'ngx-dragdrop';
            this.setDefaultInstance();
        }
        Object.defineProperty(NgxDragDropService.prototype, "instanceName", {
            get: /**
             * @return {?}
             */ function () {
                return this.name;
            },
            set: /**
             * @param {?} name
             * @return {?}
             */ function (name) {
                this.name = name;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgxDragDropService.prototype.setDefaultInstance = /**
         * @return {?}
         */
            function () {
                this.name = this.defaultInstanceName;
            };
        /**
         * @return {?}
         */
        NgxDragDropService.prototype.isDefaultInstance = /**
         * @return {?}
         */
            function () {
                return this.name === this.defaultInstanceName;
            };
        NgxDragDropService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxDragDropService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgxDragDropService.ngInjectableDef = i0.defineInjectable({ factory: function NgxDragDropService_Factory() { return new NgxDragDropService(); }, token: NgxDragDropService, providedIn: "root" });
        return NgxDragDropService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var NgxDraggableDirective = /** @class */ (function () {
        function NgxDraggableDirective(el, dragDropService) {
            this.el = el;
            this.dragDropService = dragDropService;
            this._isDraggable = false;
        }
        Object.defineProperty(NgxDraggableDirective.prototype, "ngxDraggable", {
            set: /**
             * @param {?} dragEnabled
             * @return {?}
             */ function (dragEnabled) {
                /** @type {?} */
                var draggable = !!dragEnabled;
                this.el.nativeElement.setAttribute('draggable', draggable);
                this._isDraggable = draggable;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDraggableDirective.prototype.onDragStart = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.el.nativeElement === event.target) {
                    event.target.classList.add(this.ngxDraggedClass);
                    event.dataTransfer.setData('data', JSON.stringify({ dd: this.ngxDragData }));
                    if (this.ngxDragTag) {
                        this.dragDropService.instanceName = this.ngxDragTag;
                    }
                    else {
                        this.dragDropService.setDefaultInstance();
                    }
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDraggableDirective.prototype.onDragEnd = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (this.el.nativeElement === event.target) {
                    event.target.classList.remove(this.ngxDraggedClass);
                }
            };
        NgxDraggableDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[ngxDraggable]'
                    },] }
        ];
        /** @nocollapse */
        NgxDraggableDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: NgxDragDropService }
            ];
        };
        NgxDraggableDirective.propDecorators = {
            ngxDraggable: [{ type: i0.Input }],
            ngxDragTag: [{ type: i0.Input }],
            ngxDraggedClass: [{ type: i0.Input }],
            ngxDragData: [{ type: i0.Input }],
            onDragStart: [{ type: i0.HostListener, args: ['dragstart', ['$event'],] }],
            onDragEnd: [{ type: i0.HostListener, args: ['dragend', ['$event'],] }]
        };
        return NgxDraggableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var NgxDroppableDirective = /** @class */ (function () {
        function NgxDroppableDirective(el, dragDropService) {
            this.el = el;
            this.dragDropService = dragDropService;
            this.ngxDroppable = new i0.EventEmitter();
            this.ngxDropTags = [this.dragDropService.instanceName];
        }
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDroppableDirective.prototype.onDragEnter = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (event.preventDefault) {
                    event.preventDefault();
                }
                if (event.stopPropagation) {
                    event.stopPropagation();
                }
                if (this.el.nativeElement === event.target) {
                    if (this.ngxDropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                        event.target.classList.add(this.dragDropService.instanceName);
                    }
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDroppableDirective.prototype.onDragOver = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (event.preventDefault) {
                    event.preventDefault();
                }
                if (event.stopPropagation) {
                    event.stopPropagation();
                }
                if (this.el.nativeElement === event.target) {
                    if (this.ngxDropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                        event.dataTransfer.effectAllowed = 'all';
                        event.dataTransfer.dropEffect = 'move';
                    }
                    else {
                        event.dataTransfer.effectAllowed = 'none';
                        event.dataTransfer.dropEffect = 'none';
                    }
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDroppableDirective.prototype.onDragLeave = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (event.preventDefault) {
                    event.preventDefault();
                }
                if (event.stopPropagation) {
                    event.stopPropagation();
                }
                if (this.el.nativeElement === event.target) {
                    if (this.ngxDropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                        event.target.classList.remove(this.dragDropService.instanceName);
                    }
                }
            };
        /**
         * @param {?} event
         * @return {?}
         */
        NgxDroppableDirective.prototype.onDrop = /**
         * @param {?} event
         * @return {?}
         */
            function (event) {
                if (event.preventDefault) {
                    event.preventDefault();
                }
                if (event.stopPropagation) {
                    event.stopPropagation();
                }
                if (this.el.nativeElement === event.target) {
                    /** @type {?} */
                    var dragTag = this.dragDropService.instanceName;
                    /** @type {?} */
                    var data = event.dataTransfer.getData('data');
                    /** @type {?} */
                    var dragData = void 0;
                    try {
                        dragData = JSON.parse(data).dd;
                        if (this.ngxDropTags.indexOf(this.dragDropService.instanceName) !== -1) {
                            event.target.classList.remove(this.dragDropService.instanceName);
                            this.ngxDroppable.emit({ dragTag: dragTag, dragData: dragData, dropData: this.ngxDropData });
                        }
                    }
                    catch (e) {
                        if (console && typeof console.log === 'function') {
                            console.log(e);
                            console.log('Drop failed! Data: ', data);
                        }
                    }
                }
            };
        NgxDroppableDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[ngxDroppable]'
                    },] }
        ];
        /** @nocollapse */
        NgxDroppableDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: NgxDragDropService }
            ];
        };
        NgxDroppableDirective.propDecorators = {
            ngxDroppable: [{ type: i0.Output }],
            ngxDropTags: [{ type: i0.Input }],
            ngxDropData: [{ type: i0.Input }],
            onDragEnter: [{ type: i0.HostListener, args: ['dragenter', ['$event'],] }],
            onDragOver: [{ type: i0.HostListener, args: ['dragover', ['$event'],] }],
            onDragLeave: [{ type: i0.HostListener, args: ['dragleave', ['$event'],] }],
            onDrop: [{ type: i0.HostListener, args: ['drop', ['$event'],] }]
        };
        return NgxDroppableDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var NgxDragDropModule = /** @class */ (function () {
        function NgxDragDropModule() {
        }
        NgxDragDropModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [],
                        declarations: [
                            NgxDraggableDirective,
                            NgxDroppableDirective
                        ],
                        exports: [
                            NgxDraggableDirective,
                            NgxDroppableDirective
                        ]
                    },] }
        ];
        return NgxDragDropModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */

    exports.NgxDragDropService = NgxDragDropService;
    exports.NgxDraggableDirective = NgxDraggableDirective;
    exports.NgxDroppableDirective = NgxDroppableDirective;
    exports.NgxDragDropModule = NgxDragDropModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-dragdrop.umd.js.map